// $Id: dynosearcho.js,v 1.2.2.1.2.1 2009/03/26 08:11:45 nk Exp $

/**
 * Register DynoSearcho behavior 
*/
Drupal.behaviors.dynosearcho = function (context) { 
  $('input.dynosearcho-searchbox').each(function () {
    var delta = $(this).parent().siblings("input[name='dynosearcho_delta']").val();
    var input = '#edit-dynosearcho-search-' + delta;
    var expres = '#edit-dynosearcho-exp-' + delta;
    var wrapper = '#dynosearcho-results-' + delta; 
    var searchon = $('#edit-dynosearcho-integrated-search-' + delta).val();
    $('#edit-dynosearcho-search-0-wrapper').css('float', 'left');
    
    Drupal.dynosearcho.check(input, wrapper);
    Drupal.dynosearcho.preventEnter (input, searchon);
    Drupal.dynosearcho.triggerAhah(input, expres, wrapper);
  });
}

Drupal.dynosearcho = new Object();

/**
 * Register DynoSearcho block configuration behavior
 */
Drupal.behaviors.dynosearchoAdmin = function (context) {
  //----- set the default state
  $('fieldset#dynosearcho-nodesearch').hide();
  $('fieldset#dynosearcho-usersearch').hide();
  switch($('input.dynosearcho-searchtype:checked').val()) {
    case 'node':
      $('fieldset#dynosearcho-nodesearch').show();
    break;
    case 'user':
      $('fieldset#dynosearcho-usersearch').show();
      break;
  }
  //----- update the boxes as radio buttons are clicked
  $('input.dynosearcho-searchtype').click(function () {
    if ($(this).val() == 'node') {
      $('fieldset#dynosearcho-usersearch').hide();
      $('fieldset#dynosearcho-nodesearch').slideDown();
    } 
    else {
      $('fieldset#dynosearcho-nodesearch').hide();
      $('fieldset#dynosearcho-usersearch').slideDown();
    } 
  });
}
/**
 * Helper function to prevent the enter key used to submit the form here, if integrated search is off
 */
Drupal.dynosearcho.preventEnter = function(input, searchon) {
  $(input).bind('keydown', function(e) {
    if (!e) {
      e = window.event;
    }
    switch (e.keyCode) {
      case 13: // enter
        if (searchon != 1) {
          e.preventDefault();
        }else{
          $(this).unbind('keyup');
        }
    }
  });
}

/**
 * Helper function - triggers blur() event on ahah form element to execute ahah search.
 */
Drupal.dynosearcho.triggerAhah = function(input, expres, wrapper) {
  var delay = 300;
  $(input).unbind('keyup').bind('keyup', function () {
    if (this.value.length == 0) {
      $(wrapper).hide();
      $(wrapper).empty();
    }else{
      $(wrapper).show();
      $('.throbber').remove();
      $(expres).val(this.value);
        if (this.timer) {
          clearTimeout(this.timer);
        }
        this.timer = setTimeout(function() {
          $(expres).blur();
        }, delay);
    }
    });
}

/**
 * Helper function - show wrapper when checkbox is checked.
 */
Drupal.dynosearcho.check = function(input, wrapper) {
  $('.dynosearcho-boxes div.form-item input').each(function() {
    $(this).change(function() {
      if($(input).val()) {
        $(wrapper).show();
      }
    });
  });
}